/* 
	     
	    
	 .

	 -   mgs2001@pochtamt.ru
*/

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

typedef signed __int64 ftw_t;	/* ,         */

#define DDSBITS 32	/*  FTW  DDS */

/*      FTW     DDS */
static ftw_t freq2ftw(long osc, unsigned long freq)
{
        ftw_t t = (ftw_t) freq << DDSBITS;		/*       */
        return t / osc;
}

/*     -   FTW      DDS */
static double ftw2freq(long osc, ftw_t phase)
{
        return (double) osc * phase / pow(2, DDSBITS);
}



void main(int argc, char * * argv)
{
        long fq1 = 55000002;	/* ,        */

		if (argc > 1)
			fq1 = strtol(argv [1], NULL, 10);	/*         */
		if (fq1 < 0)
			return;



        /*   -         ,     */
		const long r1 = 23;			/*   DDS -     PLL */
		const long freqlow = 45000000;	/*     */
        const long osc =  80000000;   /*     DDS */


        const long cf =   10700000;   /*      DDS */
        const long df =   (long) (((ftw_t)cf * cf) / (freqlow * r1));   /*      DDS */
        const ftw_t ph1_min = freq2ftw(osc, cf - df / 2);	/* ,      DDS */


		/*        DDS */
        printf("dds center = %ld kHz, dds bw = %ld kHz\n", cf / 1000, df / 1000);

#if 1
		/*        64- */
        ftw_t ph1_m = freq2ftw(osc, fq1) * r1;   /*       */

#else
        const long osc_m =  osc * r1;   /*     DDS -   -     */

		/*          64 bit */
		ftw_t ph1_m = freq2ftw(osc_m, fq1);    /*       */
#endif

		//  

        long n1 = (long) (ph1_m / ph1_min);		/*       PLL */

        ftw_t ph1a = ph1_m / n1;		/* FTW  DDS */

		/*      -        */        

        printf("DDS out = %6.6f Hz\n", ftw2freq(osc, ph1a));
        printf("PLL R/N = %ld/%ld\n", (long) r1, (long) n1);
        printf("PLL out = %6.6f Hz (desired = %6.6f Hz)\n", ftw2freq(osc, ph1a) * n1 / r1, (double) fq1);
}

